library serializer.test.models.Author;

import 'package:jaguar_serializer/serializer.dart';

part 'author.g.dart';

@GenSerializer(addTypeInfo: true)
class AuthorSerializer extends Serializer<Author> with _$AuthorSerializer {
  Author createModel() => new Author();

  AuthorSerializer();

  @override
  String typeString() => '$Author';
}

@GenSerializer(addTypeInfo: true)
class AuthorYamlSerializer extends Serializer<Author>
    with _$AuthorYamlSerializer {
  Author createModel() => new Author();

  AuthorYamlSerializer();

  @override
  String typeKey() => '(t)';

  @override
  String typeString() => '$Author';
}

/// Author model
class Author {
  /// Name of the author
  String name;

  bool operator ==(Object other) {
    if (other is Author) {
      return name == other.name;
    }

    return false;
  }
}
